
#ifndef SpRecordLibTypesH
#define SpRecordLibTypesH

#include <winerror.h>
#include <windef.h>

//     

#define  SPR_CHANNEL_HARDNAME                 0x00000001
#define  SPR_CHANNEL_USERNAME                 0x00000002
#define  SPR_CHANNEL_EXCLUSIVE                0x00000004

//   

#define  SPR_E_BASE                           _HRESULT_TYPEDEF_(0x80040200L)
#define  SPR_S_BASE                           _HRESULT_TYPEDEF_(0x00040200L)

#define  SPR_S_OK                             S_OK
#define  SPR_S_FALSE                          S_FALSE

#define  SPR_S_CONNECTIONNOTFOUND             _HRESULT_TYPEDEF_(SPR_S_BASE + 0x0001)
#define  SPR_S_WAITDISCONNECTTIMEOUT          _HRESULT_TYPEDEF_(SPR_S_BASE + 0x0002)
#define  SPR_S_WAIT_TIMEOUT                   _HRESULT_TYPEDEF_(SPR_S_BASE + 0x0003)

#define  SPR_E_ACCESS_DENIED                  _HRESULT_TYPEDEF_(SPR_E_BASE + 0x1001)
#define  SPR_E_CONNECT_LIMIT                  _HRESULT_TYPEDEF_(SPR_E_BASE + 0x1002)
#define  SPR_E_NOTFOUNDCHANNELNAME            _HRESULT_TYPEDEF_(SPR_E_BASE + 0x1003)
#define  SPR_E_SOCKETOPEN                     _HRESULT_TYPEDEF_(SPR_E_BASE + 0x1004)
#define  SPR_E_WAIT_FAILED                    _HRESULT_TYPEDEF_(SPR_E_BASE + 0x1005)
#define  SPR_E_CLIENTSOCKETOPEN               _HRESULT_TYPEDEF_(SPR_E_BASE + 0x1006)
#define  SPR_E_NOCONNECT                      _HRESULT_TYPEDEF_(SPR_E_BASE + 0x1007)
#define  SPR_E_INSUFFICIENT_BUFFER            _HRESULT_TYPEDEF_(SPR_E_BASE + 0x1008)
#define  SPR_E_NOMEMORY                       _HRESULT_TYPEDEF_(SPR_E_BASE + 0x1009)

#define  SPR_E_UNKNOWNCMD                     _HRESULT_TYPEDEF_(SPR_E_BASE + 0x100A)
#define  SPR_E_NOTSUPPORT                     _HRESULT_TYPEDEF_(SPR_E_BASE + 0x100B)
#define  SPR_E_INVALIDNUMBER                  _HRESULT_TYPEDEF_(SPR_E_BASE + 0x100C)
#define  SPR_E_ALREADYUSE                     _HRESULT_TYPEDEF_(SPR_E_BASE + 0x100D)
#define  SPR_E_INEXCLUSIVEMODE                _HRESULT_TYPEDEF_(SPR_E_BASE + 0x100E)
#define  SPR_E_NUMBERISDIALING                _HRESULT_TYPEDEF_(SPR_E_BASE + 0x100F)
#define  SPR_E_CMDWAITERROR                   _HRESULT_TYPEDEF_(SPR_E_BASE + 0x1010)
#define  SPR_E_LIBVERSION                     _HRESULT_TYPEDEF_(SPR_E_BASE + 0x1011)
#define  SPR_E_OUTPUTMODEALREADYUSE           _HRESULT_TYPEDEF_(SPR_E_BASE + 0x1012)
#define  SPR_E_NOTINOUTPUTMODE                _HRESULT_TYPEDEF_(SPR_E_BASE + 0x1013)
#define  SPR_E_HANDSETTAKENOTHERUSER          _HRESULT_TYPEDEF_(SPR_E_BASE + 0x1014)
#define  SPR_E_HANDSETNOTTAKE                 _HRESULT_TYPEDEF_(SPR_E_BASE + 0x1015)
#define  SPR_E_NOTWRITING                     _HRESULT_TYPEDEF_(SPR_E_BASE + 0x1016)
#define  SPR_E_USEEVENTOBJECT                 _HRESULT_TYPEDEF_(SPR_E_BASE + 0x1017)
#define  SPR_E_DEVICENOTUSE                   _HRESULT_TYPEDEF_(SPR_E_BASE + 0x1018)
#define  SPR_E_CHANNELNOTUSE                  _HRESULT_TYPEDEF_(SPR_E_BASE + 0x1019)
#define  SPR_E_NOTFOUNDDEVICENAME             _HRESULT_TYPEDEF_(SPR_E_BASE + 0x101A)
#define  SPR_E_NORECORDDETECT                 _HRESULT_TYPEDEF_(SPR_E_BASE + 0x101B)
#define  SPR_E_ALREADYWRITEAUTO               _HRESULT_TYPEDEF_(SPR_E_BASE + 0x101C)
#define  SPR_E_ALREADYWRITEUSER               _HRESULT_TYPEDEF_(SPR_E_BASE + 0x101D)
#define  SPR_E_NOTYOURWRITING                 _HRESULT_TYPEDEF_(SPR_E_BASE + 0x101E)
#define  SPR_E_VOICEMAILWORKING               _HRESULT_TYPEDEF_(SPR_E_BASE + 0x101F)
#define  SPR_E_SENDCMDPARAM                   _HRESULT_TYPEDEF_(SPR_E_BASE + 0x1020)
#define  SPR_E_SPRECORDPRGNOTFOUND            _HRESULT_TYPEDEF_(SPR_E_BASE + 0x1021)
#define  SPR_E_USERNAMEORPASSWORD             _HRESULT_TYPEDEF_(SPR_E_BASE + 0x1022)

#define  SPR_E_UNKNOWNERROR                   _HRESULT_TYPEDEF_(SPR_E_BASE + 0x1100)

//     

#define  SPR_DEVICE_SUPPORT_LINESTATE         0x00000001
#define  SPR_DEVICE_SUPPORT_VOICEMAIL         0x00000002
#define  SPR_DEVICE_SUPPORT_ISDNBRI           0x00000004
#define  SPR_DEVICE_SUPPORT_ISDN              0x00000008
#define  SPR_DEVICE_SUPPORT_DIGITAL           0x00000010

#define  SPR_DEVICE_SUPORT_LINESTATE          SPR_DEVICE_SUPPORT_LINESTATE
#define  SPR_DEVICE_SUPORT_VOICEMAIL          SPR_DEVICE_SUPPORT_VOICEMAIL
#define  SPR_DEVICE_SUPORT_ISDNBRI            SPR_DEVICE_SUPPORT_ISDNBRI

//      

#define  SPR_AUDIODATA_BEGIN                  0x00000001
#define  SPR_AUDIODATA_END                    0x00000002

//   

#define  DIAL_PULSE                           0x00000001
#define  DIAL_TONE                            0x00000002

//    

#define  SPR_MSG_RECORD_START                 0x00000001
#define  SPR_MSG_RING                         0x00000002
#define  SPR_MSG_ANI_DETECT                   0x00000003
#define  SPR_MSG_RECORD_TYPE                  0x00000004
#define  SPR_MSG_DIALLED_PHONE                0x00000005
#define  SPR_MSG_MISSED_PHONE                 0x00000006
#define  SPR_MSG_RECORD_STOP                  0x00000007
#define  SPR_MSG_DEVICE_CONNECTED             0x00000008
#define  SPR_MSG_DEVICE_DISCONNECTED          0x00000009
#define  SPR_MSG_CONVERSATION_BEGIN           0x0000000A
#define  SPR_MSG_CONVERSATION_END             0x0000000B
#define  SPR_MSG_COMPRESSING_FINISHED         0x0000000C
#define  SPR_MSG_FAX_DETECTED                 0x0000000D

//    

#define  SPR_MSG_C_RECORD_START               0x00008001
#define  SPR_MSG_C_RING                       0x00008002
#define  SPR_MSG_C_ANI_DETECT                 0x00008003
#define  SPR_MSG_C_RECORD_TYPE                0x00008004
#define  SPR_MSG_C_DIALLED_PHONE              0x00008005
#define  SPR_MSG_C_MISSED_PHONE               0x00008006
#define  SPR_MSG_C_RECORD_STOP                0x00008007

#define  SPR_MSG_C_AUDIODATA                  0x00008008
#define  SPR_MSG_C_DIALINGISCOMPLETED         0x00008009
#define  SPR_MSG_C_DTMF                       0x0000800A
#define  SPR_MSG_C_LINEBUSY                   0x0000800B
#define  SPR_MSG_C_AUDIOBUFSTATE              0x0000800C
#define  SPR_MSG_C_LINEOFF                    0x0000800D
#define  SPR_MSG_C_LINEON                     0x0000800E
#define  SPR_MSG_C_HANDSETOFF                 0x0000800F
#define  SPR_MSG_C_HANDSETON                  0x00008010
#define  SPR_MSG_C_TARGETTAKENHANDSET         0x00008011
#define  SPR_MSG_C_CONVERSATION_BEGIN         0x00008012
#define  SPR_MSG_C_CONVERSATION_END           0x00008013
#define  SPR_MSG_C_PHONEHANDSETON             0x00008014
#define  SPR_MSG_C_CALLSENDINGCONTROL         0x00008015
#define  SPR_MSG_C_FILECREATEERROR            0x00008016
#define  SPR_MSG_C_CARRIER                    0x00008017
#define  SPR_MSG_C_FAX_DETECTED               0x00008018

//  

#define  SPR_MSG_CHANGE_CHANNEL_NAME          0x00010001
#define  SPR_MSG_TEXT                         0x00010002
#define  SPR_MSG_POWERSUSPEND                 0x00010003
#define  SPR_MSG_DESTROY_CONNECTION           0x000100FF

//    MSGDestroyConnection.dwDestroyReason

#define  SPR_DR_PROGRAM_EXIT                  0x00
#define  SPR_DR_DISABLED                      0x01
#define  SPR_DR_CONNECTIONERROR               0x02
#define  SPR_DR_SWITCHEDOFF                   0x03
#define  SPR_DR_DEVICEERROR                   0x04
#define  SPR_DR_UNKNOWN                       0xFF

//  

#define  SPR_RT_UNKNOWN                       0x0000
#define  SPR_RT_RECEIVED                      0x0001
#define  SPR_RT_DIALLED                       0x0002
#define  SPR_RT_MISSED                        0x0004
#define  SPR_RT_BYLEVEL                       0x0008
#define  SPR_RT_BYCOMMAND                     0x0010
#define  SPR_RT_VOICEMAIL                     0x0020
#define  SPR_RT_FRAGMENT                      0x0040

// DTMF - 

#define  SPR_DTMF_0                           0x00
#define  SPR_DTMF_1                           0x01
#define  SPR_DTMF_2                           0x02
#define  SPR_DTMF_3                           0x03
#define  SPR_DTMF_4                           0x04
#define  SPR_DTMF_5                           0x05
#define  SPR_DTMF_6                           0x06
#define  SPR_DTMF_7                           0x07
#define  SPR_DTMF_8                           0x08
#define  SPR_DTMF_9                           0x09
#define  SPR_DTMF_STAR                        0x0A
#define  SPR_DTMF_POUND                       0x0B
#define  SPR_DTMF_A                           0x0C
#define  SPR_DTMF_B                           0x0D
#define  SPR_DTMF_C                           0x0E
#define  SPR_DTMF_D                           0x0F
#define  SPR_DTMF_UNKNOWN                     0xFF

//  

#define  SPR_MAX_MSG_SIZE                     32768
#define  MAX_CHANNEL_NAME_SIZE                36
#define  MAX_PHONE_NUMBER_SIZE                32
#define  MAX_DEVICE_NAME_SIZE                 64
#define  MAX_SEND_AUDIO_DATA_SIZE             SPR_MAX_MSG_SIZE - 12
#define  MAX_COMMENT_CHARS                    4096

#pragma pack(push, 1)

//  

typedef struct _MSGHEADER {
  DWORD dwMsgSize;
  DWORD dwMsg;
  DATE MsgTime;
} MSGHEADER, *PMSGHEADER, *LPMSGHEADER;

//    

typedef struct _MSGCHANNELNAME {
  MSGHEADER mh;
  char cbChannelName[MAX_CHANNEL_NAME_SIZE];
} MSGCHANNELNAME, *PMSGCHANNELNAME, *LPMSGCHANNELNAME;

typedef struct _MSGRING {
  MSGHEADER mh;
  char cbChannelName[MAX_CHANNEL_NAME_SIZE];
  DWORD dwRingCount;
} MSGRING, *PMSGRING, *LPMSGRING;

typedef struct _MSGRECORDSTART {
  MSGHEADER mh;
  char cbChannelName[MAX_CHANNEL_NAME_SIZE];
  DWORD dwRecordType;
  char cbPhoneNumber[MAX_PHONE_NUMBER_SIZE];
  char cbFileName[MAX_PATH];
} MSGRECORDSTART, *PMSGRECORDSTART, *LPMSGRECORDSTART;

typedef struct _MSGRECORDSTOP {
  MSGHEADER mh;
  char cbChannelName[MAX_CHANNEL_NAME_SIZE];
  DWORD dwRecordType;
  char cbPhoneNumber[MAX_PHONE_NUMBER_SIZE];
  char cbFileName[MAX_PATH];
  DWORD dwLeng;
  BOOL NormalStop;
} MSGRECORDSTOP, *PMSGRECORDSTOP, *LPMSGRECORDSTOP;

typedef struct _MSGPHONENUMBER {
  MSGHEADER mh;
  char cbChannelName[MAX_CHANNEL_NAME_SIZE];
  char cbPhoneNumber[MAX_PHONE_NUMBER_SIZE];
} MSGPHONENUMBER, *PMSGPHONENUMBER, *LPMSGPHONENUMBER;

typedef struct _MSGRECORDTYPE {
  MSGHEADER mh;
  char cbChannelName[MAX_CHANNEL_NAME_SIZE];
  DWORD dwRecordType;
} MSGRECORDTYPE, *PMSGRECORDTYPE, *LPMSGRECORDTYPE;

typedef struct _MSGCHANGECHANNELNAME {
  MSGHEADER mh;
  char cbOldChannelName[MAX_CHANNEL_NAME_SIZE];
  char cbNewChannelName[MAX_CHANNEL_NAME_SIZE];
} MSGCHANGECHANNELNAME, *PMSGCHANGECHANNELNAME, *LPMSGCHANGECHANNELNAME;

typedef struct _MSGTEXT {
  MSGHEADER mh;
  char cbText[1];
} MSGTEXT, *PMSGTEXT, *LPMSGTEXT;

typedef struct _MSGDESTROYCONNECTION {
  MSGHEADER mh;
  DWORD dwDestroyReason;
} MSGDESTROYCONNECTION, *PMSGDESTROYCONNECTION, *LPMSGDESTROYCONNECTION;

typedef struct _MSGDEVICENAME {
  MSGHEADER mh;
  char cbDeviceName[MAX_DEVICE_NAME_SIZE];
} MSGDEVICENAME, *PMSGDEVICENAME, *LPMSGDEVICENAME;

typedef struct _MSGDEVICEDISCONNECT {
  MSGHEADER mh;
  char cbDeviceName[MAX_DEVICE_NAME_SIZE];
  DWORD dsDisconnectReason;
} MSGDEVICEDISCONNECT, *PMSGDEVICEDISCONNECT, *LPMSGDEVICEDISCONNECT;

typedef struct _MSGCOMPRESSINGFINISHED {
  MSGHEADER mh;
  char cbFileName[MAX_PATH];
} MSGCOMPRESSINGFINISHED, *PMSGCOMPRESSINGFINISHED, *LPMSGCOMPRESSINGFINISHED;

//    

typedef struct _CHANNELMSGRING {
  MSGHEADER mh;
  DWORD dwRingCount;
} CHANNELMSGRING, *PCHANNELMSGRING, *LPCHANNELMSGRING;

typedef struct _CHANNELMSGRECORDSTART {
  MSGHEADER mh;
  DWORD dwRecordType;
  char cbPhoneNumber[MAX_PHONE_NUMBER_SIZE];
  char cbFileName[MAX_PATH];
} CHANNELMSGRECORDSTART, *PCHANNELMSGRECORDSTART, *LPCHANNELMSGRECORDSTART;

typedef struct _CHANNELMSGRECORDSTOP {
  MSGHEADER mh;
  DWORD dwRecordType;
  char cbPhoneNumber[MAX_PHONE_NUMBER_SIZE];
  char cbFileName[MAX_PATH];
  DWORD dwLeng;
  BOOL NormalStop;
} CHANNELMSGRECORDSTOP, *PCHANNELMSGRECORDSTOP, *LPCHANNELMSGRECORDSTOP;

typedef struct _CHANNELMSGPHONENUMBER {
  MSGHEADER mh;
  char cbPhoneNumber[MAX_PHONE_NUMBER_SIZE];
} CHANNELMSGPHONENUMBER, *PCHANNELMSGPHONENUMBER, *LPCHANNELMSGPHONENUMBER;

typedef struct _CHANNELMSGRECORDTYPE {
  MSGHEADER mh;
  DWORD dwRecordType;
} CHANNELMSGRECORDTYPE, *PCHANNELMSGRECORDTYPE, *LPCHANNELMSGRECORDTYPE;

typedef struct _CHANNELMSGDATA {
  MSGHEADER mh;
  DWORD dwDataSize;
  unsigned char cbData[1];
} CHANNELMSGDATA, *PCHANNELMSGDATA, *LPCHANNELMSGDATA;

typedef struct _CHANNELMSGDTMFCODE {
  MSGHEADER mh;
  DWORD dwDTMFCode;
} CHANNELMSGDTMFCODE, *PCHANNELMSGDTMFCODE, *LPCHANNELMSGDTMFCODE;

typedef struct _CHANNELMSGAUDIOBUFSTATE {
  MSGHEADER mh;
  DWORD dwMilliseconds;
} CHANNELMSGAUDIOBUFSTATE, *PCHANNELMSGAUDIOBUFSTATE, *LPCHANNELMSGAUDIOBUFSTATE;

#pragma pack(pop)

#endif
